#!/usr/bin/perl
#
#CactiHelper version 0.1, create some queries script/xml file for Cacti 8.6
#Copyright (C) 2005  Lechavalier Olivier <olivier.lechevalier@euromed-marseille.com>
#
#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

use encoding "utf8",STDOUT => "latin1",STDIN => "latin1";

if (($ARGV[1] ne "query") && ($ARGV[1] ne "get") && ($ARGV[1] ne "index")) {
	print "usage:\n\n./query_wmi_counters.pl ip index\n./query_wmi_counters.pl ip query {index,counter_name,value}\n./query_wmi_counter.pl ip get {index,counter_name,value} index\n";
	exit;
}

my $check_nt_path = "/usr/local/nagios/libexec/check_nt";

sub getValue{
	my($counter_name,$ip) = @_;
	my $ret = `$check_nt_path -H $ip -p 1248 -v COUNTER -l \"$counter_name\"`;
	chomp $ret;
	return($ret);
}



@1@


if($ARGV[1] eq "index") {
	for(my $i = 1;$i <= $#counters+1;$i++)
	{ print "$i\n"; }
	exit;
}

if($ARGV[1] eq "query"){
	if($ARGV[2] eq "index"){
			for(my $i = 1;$i <= $#counters+1;$i++)
			{	print "$i!$i\n";	}
			exit;
		}
		
		if($ARGV[2] eq "counter_name"){
			for(my $i = 1;$i <= $#counters+1;$i++)
			{	my $c = $counters[$i-1];
				$c =~ s/\\/\\\\/g;
				$c =~ s/'/''/g;
				print "$i!$c\n"; }
			exit;
		}
		
		if($ARGV[2] eq "value"){
				for(my $i = 1;$i <= $#counters+1;$i++){
					my $ret = getValue($counters[i-1],$ARGV[0]);
					print "$i!$ret\n";
				}
				exit;
		}
	exit;
}

if($ARGV[1] eq "get"){
	if($ARGV[2] eq "index"){
		print "$ARGV[3]\n";
		exit;
	}
	
	if($ARGV[2] eq "counter_name"){
		my $c = $counters[$ARGV[3]-1];
		$c =~ s/\\/\\\\/g;
		$c =~ s/'/''/g;
		print "$c\n";
		exit;
	}
	
	if($ARGV[2] eq "value"){
			
			my $ret = getValue($counters[$ARGV[3]-1],$ARGV[0]);
			print "$ret\n";
			exit;
	}
	exit;
}
	
		
